diff a/test/jdk/java/lang/ScopedValue/ScopedValueAPI.java b/test/jdk/java/lang/ScopedValue/ScopedValueAPI.java
--- a/test/jdk/java/lang/ScopedValue/ScopedValueAPI.java
+++ b/test/jdk/java/lang/ScopedValue/ScopedValueAPI.java
@@ -46,34 +46,34 @@
     private static Stream<ThreadFactory> factories() {
         return Stream.of(Thread.ofPlatform().factory(), Thread.ofVirtual().factory());
     }
 
     /**
-     * Test that runWhere invokes the Runnable's run method.
+     * Test that where invokes the Runnable's run method.
      */
     @ParameterizedTest
     @MethodSource("factories")
     void testRunWhere(ThreadFactory factory) throws Exception {
         test(factory, () -> {
             class Box { static boolean executed; }
             ScopedValue<String> name = ScopedValue.newInstance();
-            ScopedValue.runWhere(name, "duke", () -> { Box.executed = true; });
+            ScopedValue.where(name, "duke").run(() -> { Box.executed = true; });
             assertTrue(Box.executed);
         });
     }
 
     /**
-     * Test runWhere when the run method throws an exception.
+     * Test where when the run method throws an exception.
      */
     @ParameterizedTest
     @MethodSource("factories")
     void testRunWhereThrows(ThreadFactory factory) throws Exception {
         test(factory, () -> {
             class FooException extends RuntimeException {  }
             ScopedValue<String> name = ScopedValue.newInstance();
             Runnable op = () -> { throw new FooException(); };
-            assertThrows(FooException.class, () -> ScopedValue.runWhere(name, "duke", op));
+            assertThrows(FooException.class, () -> ScopedValue.where(name, "duke").run(op));
             assertFalse(name.isBound());
         });
     }
 
     /**
@@ -82,11 +82,11 @@
     @ParameterizedTest
     @MethodSource("factories")
     void testCallWhere(ThreadFactory factory) throws Exception {
         test(factory, () -> {
             ScopedValue<String> name = ScopedValue.newInstance();
-            String result = ScopedValue.callWhere(name, "duke", name::get);
+            String result = ScopedValue.where(name, "duke").call(name::get);
             assertEquals("duke", result);
         });
     }
 
     /**
@@ -97,11 +97,11 @@
     void testCallWhereThrows(ThreadFactory factory) throws Exception {
         test(factory, () -> {
             class FooException extends RuntimeException {  }
             ScopedValue<String> name = ScopedValue.newInstance();
             CallableOp<Void, RuntimeException> op = () -> { throw new FooException(); };
-            assertThrows(FooException.class, () -> ScopedValue.callWhere(name, "duke", op));
+            assertThrows(FooException.class, () -> ScopedValue.where(name, "duke").call(op));
             assertFalse(name.isBound());
         });
     }
 
     /**
@@ -114,21 +114,21 @@
             ScopedValue<String> name1 = ScopedValue.newInstance();
             ScopedValue<String> name2 = ScopedValue.newInstance();
             assertThrows(NoSuchElementException.class, name1::get);
             assertThrows(NoSuchElementException.class, name2::get);
 
-            // runWhere
-            ScopedValue.runWhere(name1, "duke", () -> {
+            // where
+            ScopedValue.where(name1, "duke").run(() -> {
                 assertEquals("duke", name1.get());
                 assertThrows(NoSuchElementException.class, name2::get);
 
             });
             assertThrows(NoSuchElementException.class, name1::get);
             assertThrows(NoSuchElementException.class, name2::get);
 
             // callWhere
-            ScopedValue.callWhere(name1, "duke", () -> {
+            ScopedValue.where(name1, "duke").call(() -> {
                 assertEquals("duke", name1.get());
                 assertThrows(NoSuchElementException.class, name2::get);
                 return null;
             });
             assertThrows(NoSuchElementException.class, name1::get);
@@ -146,20 +146,20 @@
             ScopedValue<String> name1 = ScopedValue.newInstance();
             ScopedValue<String> name2 = ScopedValue.newInstance();
             assertFalse(name1.isBound());
             assertFalse(name2.isBound());
 
-            // runWhere
-            ScopedValue.runWhere(name1, "duke", () -> {
+            // where
+            ScopedValue.where(name1, "duke").run(() -> {
                 assertTrue(name1.isBound());
                 assertFalse(name2.isBound());
             });
             assertFalse(name1.isBound());
             assertFalse(name2.isBound());
 
             // callWhere
-            ScopedValue.callWhere(name1, "duke", () -> {
+            ScopedValue.where(name1, "duke").call(() -> {
                 assertTrue(name1.isBound());
                 assertFalse(name2.isBound());
                 return null;
             });
             assertFalse(name1.isBound());
@@ -176,18 +176,18 @@
         test(factory, () -> {
             ScopedValue<String> name = ScopedValue.newInstance();
             assertNull(name.orElse(null));
             assertEquals("default", name.orElse("default"));
 
-            // runWhere
-            ScopedValue.runWhere(name, "duke", () -> {
+            // where
+            ScopedValue.where(name, "duke").run(() -> {
                 assertEquals("duke", name.orElse(null));
                 assertEquals("duke", name.orElse("default"));
             });
 
             // callWhere
-            ScopedValue.callWhere(name, "duke", () -> {
+            ScopedValue.where(name, "duke").call(() -> {
                 assertEquals("duke", name.orElse(null));
                 assertEquals("duke", name.orElse("default"));
                 return null;
             });
         });
@@ -202,17 +202,17 @@
         test(factory, () -> {
             class FooException extends RuntimeException { }
             ScopedValue<String> name = ScopedValue.newInstance();
             assertThrows(FooException.class, () -> name.orElseThrow(FooException::new));
 
-            // runWhere
-            ScopedValue.runWhere(name, "duke", () -> {
+            // where
+            ScopedValue.where(name, "duke").run(() -> {
                 assertEquals("duke", name.orElseThrow(FooException::new));
             });
 
             // callWhere
-            ScopedValue.callWhere(name, "duke", () -> {
+            ScopedValue.where(name, "duke").call(() -> {
                 assertEquals("duke", name.orElseThrow(FooException::new));
                 return null;
             });
         });
     }
@@ -257,31 +257,31 @@
     @MethodSource("factories")
     void testRebinding(ThreadFactory factory) throws Exception {
         test(factory, () -> {
             ScopedValue<String> name = ScopedValue.newInstance();
 
-            // runWhere
-            ScopedValue.runWhere(name, "duke", () -> {
+            // where
+            ScopedValue.where(name, "duke").run(() -> {
                 assertTrue(name.isBound());
                 assertEquals("duke", name.get());
 
-                ScopedValue.runWhere(name, "duchess", () -> {
+                ScopedValue.where(name, "duchess").run(() -> {
                     assertTrue(name.isBound());
                     assertEquals("duchess", name.get());
                 });
 
                 assertTrue(name.isBound());
                 assertEquals("duke", name.get());
             });
             assertFalse(name.isBound());
 
             // callWhere
-            ScopedValue.callWhere(name, "duke", () -> {
+            ScopedValue.where(name, "duke").call(() -> {
                 assertTrue(name.isBound());
                 assertEquals("duke", name.get());
 
-                ScopedValue.callWhere(name, "duchess", () -> {
+                ScopedValue.where(name, "duchess").call(() -> {
                     assertTrue(name.isBound());
                     assertEquals("duchess", name.get());
                     return null;
                 });
 
@@ -300,31 +300,31 @@
     @MethodSource("factories")
     void testRebindingFromNull(ThreadFactory factory) throws Exception {
         test(factory, () -> {
             ScopedValue<String> name = ScopedValue.newInstance();
 
-            // runWhere
-            ScopedValue.runWhere(name, null, () -> {
+            // where
+            ScopedValue.where(name, null).run(() -> {
                 assertTrue(name.isBound());
                 assertNull(name.get());
 
-                ScopedValue.runWhere(name, "duchess", () -> {
+                ScopedValue.where(name, "duchess").run(() -> {
                     assertTrue(name.isBound());
                     assertTrue("duchess".equals(name.get()));
                 });
 
                 assertTrue(name.isBound());
                 assertNull(name.get());
             });
             assertFalse(name.isBound());
 
             // callWhere
-            ScopedValue.callWhere(name, null, () -> {
+            ScopedValue.where(name, null).call(() -> {
                 assertTrue(name.isBound());
                 assertNull(name.get());
 
-                ScopedValue.callWhere(name, "duchess", () -> {
+                ScopedValue.where(name, "duchess").call(() -> {
                     assertTrue(name.isBound());
                     assertTrue("duchess".equals(name.get()));
                     return null;
                 });
 
@@ -343,31 +343,31 @@
     @MethodSource("factories")
     void testRebindingToNull(ThreadFactory factory) throws Exception {
         test(factory, () -> {
             ScopedValue<String> name = ScopedValue.newInstance();
 
-            // runWhere
-            ScopedValue.runWhere(name, "duke", () -> {
+            // where
+            ScopedValue.where(name, "duke").run(() -> {
                 assertTrue(name.isBound());
                 assertEquals("duke", name.get());
 
-                ScopedValue.runWhere(name, null, () -> {
+                ScopedValue.where(name, null).run(() -> {
                     assertTrue(name.isBound());
                     assertNull(name.get());
                 });
 
                 assertTrue(name.isBound());
                 assertEquals("duke", name.get());
             });
             assertFalse(name.isBound());
 
             // callWhere
-            ScopedValue.callWhere(name, "duke", () -> {
+            ScopedValue.where(name, "duke").call(() -> {
                 assertTrue(name.isBound());
                 assertEquals("duke", name.get());
 
-                ScopedValue.callWhere(name, null, () -> {
+                ScopedValue.where(name, null).call(() -> {
                     assertTrue(name.isBound());
                     assertNull(name.get());
                     return null;
                 });
 
@@ -408,15 +408,15 @@
     void testNullPointerException() {
         ScopedValue<String> name = ScopedValue.newInstance();
 
         assertThrows(NullPointerException.class, () -> ScopedValue.where(null, "duke"));
 
-        assertThrows(NullPointerException.class, () -> ScopedValue.runWhere(null, "duke", () -> { }));
-        assertThrows(NullPointerException.class, () -> ScopedValue.runWhere(name, "duke", null));
+        assertThrows(NullPointerException.class, () -> ScopedValue.where(null, "duke").run(() -> { }));
+        assertThrows(NullPointerException.class, () -> ScopedValue.where(name, "duke").run(null));
 
-        assertThrows(NullPointerException.class, () -> ScopedValue.callWhere(null, "duke", () -> ""));
-        assertThrows(NullPointerException.class, () -> ScopedValue.callWhere(name, "duke", null));
+        assertThrows(NullPointerException.class, () -> ScopedValue.where(null, "duke").call(() -> ""));
+        assertThrows(NullPointerException.class, () -> ScopedValue.where(name, "duke").call(null));
 
         assertThrows(NullPointerException.class, () -> name.orElseThrow(null));
 
         var carrier = ScopedValue.where(name, "duke");
         assertThrows(NullPointerException.class, () -> carrier.where(null, "duke"));
diff a/test/jdk/java/lang/ScopedValue/StressStackOverflow.java b/test/jdk/java/lang/ScopedValue/StressStackOverflow.java
--- a/test/jdk/java/lang/ScopedValue/StressStackOverflow.java
+++ b/test/jdk/java/lang/ScopedValue/StressStackOverflow.java
@@ -50,10 +50,11 @@
 import java.lang.ScopedValue.CallableOp;
 import java.time.Duration;
 import java.util.concurrent.ThreadLocalRandom;
 import java.util.concurrent.StructureViolationException;
 import java.util.concurrent.StructuredTaskScope;
+import java.util.concurrent.StructuredTaskScope.Joiner;
 import java.util.function.Supplier;
 
 public class StressStackOverflow {
     public static final ScopedValue<Integer> el = ScopedValue.newInstance();
 
@@ -167,11 +168,11 @@
 
     // Run op in a new thread. Platform or virtual threads are chosen at random.
     void runInNewThread(Runnable op) {
         var threadFactory
                 = (ThreadLocalRandom.current().nextBoolean() ? Thread.ofPlatform() : Thread.ofVirtual()).factory();
-        try (var scope = new StructuredTaskScope<>("", threadFactory)) {
+        try (var scope = StructuredTaskScope.open(Joiner.awaitAll(), cf -> cf.withThreadFactory(threadFactory))) {
             var handle = scope.fork(() -> {
                 op.run();
                 return null;
             });
             scope.join();
@@ -184,11 +185,11 @@
     }
 
     public void run() {
         try {
             ScopedValue.where(inheritedValue, 42).where(el, 0).run(() -> {
-                try (var scope = new StructuredTaskScope<>()) {
+                try (var scope = StructuredTaskScope.open(Joiner.awaitAll())) {
                     try {
                         if (ThreadLocalRandom.current().nextBoolean()) {
                             // Repeatedly test Scoped Values set by ScopedValue::call(), get(), and run()
                             final var deepRecursion
                                 = new DeepRecursion(DeepRecursion.Behaviour.choose(ThreadLocalRandom.current()));
diff a/test/jdk/java/lang/Thread/virtual/CancelTimerWithContention.java b/test/jdk/java/lang/Thread/virtual/CancelTimerWithContention.java
--- /dev/null
+++ b/test/jdk/java/lang/Thread/virtual/CancelTimerWithContention.java
@@ -0,0 +1,102 @@
+/*
+ * Copyright (c) 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+/*
+ * @test
+ * @summary Test cancelling a timeout task for Object.wait(millis) when there is
+ *     contention on the timer queue
+ * @key randomness
+ * @run main/othervm
+ *     -Djdk.virtualThreadScheduler.parallelism=2
+ *     -Djdk.virtualThreadScheduler.timerQueues=1
+ *     CancelTimerWithContention
+ */
+
+import java.time.Instant;
+import java.util.Random;
+import java.util.concurrent.Executors;
+import java.util.concurrent.atomic.AtomicInteger;
+
+public class CancelTimerWithContention {
+
+    // number of threads
+    private static final int MIN_THREADS = 100;
+    private static final int MAX_THREADS = 10_000;
+
+    // number of monitors to enter
+    private static final int MIN_MONITORS = 2;
+    private static final int MAX_MONITORS = 8;
+
+    private static final Random RAND = new Random();
+
+    public static void main(String[] args) {
+        for (int threadCount = MIN_THREADS; threadCount <= MAX_THREADS; threadCount += 100) {
+            System.out.format("%s #threads = %d%n", Instant.now(), threadCount);
+            for (int lockCount = MIN_MONITORS; lockCount <= MAX_MONITORS;  lockCount += 2) {
+                test(threadCount, lockCount);
+            }
+        }
+    }
+
+    /**
+     * Test threads entering monitors and using Object.wait(millis) to wait. This
+     * testing scenario leads to a mix of contention (with responsible threads using
+     * short timeouts), timed-wait, and cancellation of timer tasks. This scenario
+     * can result in contention of the timer queue.
+     */
+    static void test(int threadCount, int monitorCount) {
+        var locks = new Object[monitorCount];
+        for (int i = 0; i < monitorCount; i++) {
+            locks[i] = new Object();
+        }
+
+        try (var executor = Executors.newVirtualThreadPerTaskExecutor()) {
+            var finished = new AtomicInteger();
+
+            for (int i = 0; i < threadCount; i++) {
+                Object lock = locks[RAND.nextInt(monitorCount)];    // random lock
+
+                executor.submit(() -> {
+                    synchronized (lock) {
+                        lock.wait(Long.MAX_VALUE);
+                    }
+                    finished.incrementAndGet();
+                    return null;
+                });
+
+                synchronized (lock) {
+                    lock.notify();
+                }
+            }
+
+            // notify at most one thread until all threads are finished
+            while (finished.get() < threadCount) {
+                for (Object lock : locks) {
+                    synchronized (lock) {
+                        lock.notify();
+                    }
+                }
+            }
+        }
+    }
+}
diff a/test/jdk/java/lang/Thread/virtual/JfrEvents.java b/test/jdk/java/lang/Thread/virtual/JfrEvents.java
--- a/test/jdk/java/lang/Thread/virtual/JfrEvents.java
+++ b/test/jdk/java/lang/Thread/virtual/JfrEvents.java
@@ -60,15 +60,12 @@
 
 class JfrEvents {
 
     @BeforeAll
     static void setup() {
-        int minParallelism = 2;
-        if (Thread.currentThread().isVirtual()) {
-            minParallelism++;
-        }
-        VThreadRunner.ensureParallelism(minParallelism);
+        // need at least two carriers to test pinning
+        VThreadRunner.ensureParallelism(2);
     }
 
     /**
      * Test jdk.VirtualThreadStart and jdk.VirtualThreadEnd events.
      */
@@ -138,10 +135,227 @@
 
             assertContainsPinnedEvent(recording, vthread);
         }
     }
 
+    /**
+     * Test jdk.VirtualThreadPinned event when blocking on monitor while pinned.
+     */
+    @Test
+    void testBlockWhenPinned() throws Exception {
+        try (Recording recording = new Recording()) {
+            recording.enable("jdk.VirtualThreadPinned");
+            recording.start();
+
+            Object lock = new Object();
+
+            var started = new AtomicBoolean();
+            var vthread = Thread.ofVirtual().unstarted(() -> {
+                VThreadPinner.runPinned(() -> {
+                    started.set(true);
+                    synchronized (lock) { }
+                });
+            });
+
+            try {
+                synchronized (lock) {
+                    vthread.start();
+                    // wait for thread to start and block
+                    awaitTrue(started);
+                    await(vthread, Thread.State.BLOCKED);
+                }
+            } finally {
+                vthread.join();
+                recording.stop();
+            }
+
+            assertContainsPinnedEvent(recording, vthread);
+        }
+    }
+
+    /**
+     * Test jdk.VirtualThreadPinned event when waiting with Object.wait while pinned.
+     */
+    @ParameterizedTest
+    @ValueSource(booleans = { true, false })
+    void testObjectWaitWhenPinned(boolean timed) throws Exception {
+        try (Recording recording = new Recording()) {
+            recording.enable("jdk.VirtualThreadPinned");
+            recording.start();
+
+            Object lock = new Object();
+
+            var started = new AtomicBoolean();
+            var vthread = Thread.startVirtualThread(() -> {
+                VThreadPinner.runPinned(() -> {
+                    started.set(true);
+                    synchronized (lock) {
+                        try {
+                            if (timed) {
+                                lock.wait(Long.MAX_VALUE);
+                            } else {
+                                lock.wait();
+                            }
+                        } catch (InterruptedException e) {
+                            fail();
+                        }
+                    }
+                });
+            });
+
+            try {
+                // wait for thread to start and wait
+                awaitTrue(started);
+                await(vthread, timed ? Thread.State.TIMED_WAITING : Thread.State.WAITING);
+            } finally {
+                synchronized (lock) {
+                    lock.notifyAll();
+                }
+                vthread.join();
+                recording.stop();
+            }
+
+            assertContainsPinnedEvent(recording, vthread);
+        }
+    }
+
+    /**
+     * Test jdk.VirtualThreadPinned event when parking in a class initializer.
+     */
+    @Test
+    void testParkInClassInitializer() throws Exception {
+        class TestClass {
+            static {
+                LockSupport.park();
+            }
+            static void m() {
+                // do nothing
+            }
+        }
+
+        try (Recording recording = new Recording()) {
+            recording.enable("jdk.VirtualThreadPinned");
+            recording.start();
+
+            var started = new AtomicBoolean();
+            Thread vthread = Thread.startVirtualThread(() -> {
+                started.set(true);
+                TestClass.m();
+            });
+
+            try {
+                // wait for it to start and park
+                awaitTrue(started);
+                await(vthread, Thread.State.WAITING);
+            } finally {
+                LockSupport.unpark(vthread);
+                vthread.join();
+                recording.stop();
+            }
+
+            assertContainsPinnedEvent(recording, vthread);
+        }
+    }
+
+    /**
+     * Test jdk.VirtualThreadPinned event when blocking on monitor in a class initializer.
+     */
+    @Test
+    void testBlockInClassInitializer() throws Exception {
+        class LockHolder {
+            static final Object lock = new Object();
+        }
+        class TestClass {
+            static {
+                synchronized (LockHolder.lock) { }
+            }
+            static void m() {
+                // no nothing
+            }
+        }
+
+        try (Recording recording = new Recording()) {
+            recording.enable("jdk.VirtualThreadPinned");
+            recording.start();
+
+            var started = new AtomicBoolean();
+            Thread vthread = Thread.ofVirtual().unstarted(() -> {
+                started.set(true);
+                TestClass.m();
+            });
+
+            try {
+                synchronized (LockHolder.lock) {
+                    vthread.start();
+                    // wait for thread to start and block
+                    awaitTrue(started);
+                    await(vthread, Thread.State.BLOCKED);
+                }
+            } finally {
+                vthread.join();
+                recording.stop();
+            }
+
+            assertContainsPinnedEvent(recording, vthread);
+        }
+    }
+
+    /**
+     * Test jdk.VirtualThreadPinned event when waiting for a class initializer.
+     */
+    @Test
+    void testWaitingForClassInitializer() throws Exception {
+        class TestClass {
+            static {
+                LockSupport.park();
+            }
+            static void m() {
+                // do nothing
+            }
+        }
+
+        try (Recording recording = new Recording()) {
+            recording.enable("jdk.VirtualThreadPinned");
+            recording.start();
+
+            var started1 = new AtomicBoolean();
+            var started2 = new AtomicBoolean();
+
+            Thread vthread1 =  Thread.ofVirtual().unstarted(() -> {
+                started1.set(true);
+                TestClass.m();
+            });
+            Thread vthread2 = Thread.ofVirtual().unstarted(() -> {
+                started2.set(true);
+                TestClass.m();
+            });
+
+            try {
+                // start first virtual thread and wait for it to start + park
+                vthread1.start();
+                awaitTrue(started1);
+                await(vthread1, Thread.State.WAITING);
+
+                // start second virtual thread and wait for it to start
+                vthread2.start();
+                awaitTrue(started2);
+
+                // give time for second virtual thread to wait on the MutexLocker
+                Thread.sleep(3000);
+
+            } finally {
+                LockSupport.unpark(vthread1);
+                vthread1.join();
+                vthread2.join();
+                recording.stop();
+            }
+
+            // the recording should have a pinned event for vthread2
+            assertContainsPinnedEvent(recording, vthread2);
+        }
+    }
+
     /**
      * Test jdk.VirtualThreadSubmitFailed event.
      */
     @Test
     void testVirtualThreadSubmitFailed() throws Exception {
diff a/test/jdk/java/lang/Thread/virtual/LockingMode.java b/test/jdk/java/lang/Thread/virtual/LockingMode.java
--- /dev/null
+++ b/test/jdk/java/lang/Thread/virtual/LockingMode.java
@@ -0,0 +1,39 @@
+/*
+ * Copyright (c) 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+import java.lang.management.ManagementFactory;
+import com.sun.management.HotSpotDiagnosticMXBean;
+
+class LockingMode {
+    private LockingMode() { }
+
+    /**
+     * Returns true if using legacy locking mode.
+     */
+    static boolean isLegacy() {
+        return ManagementFactory.getPlatformMXBean(HotSpotDiagnosticMXBean.class)
+                .getVMOption("LockingMode")
+                .getValue()
+                .equals("1");
+    }
+}
